Package com.sas.metadata.remote

# Interface Email

All Superinterfaces:
  `CMetadata`, `ContentLocation`, `DeployedDataPackage`, `MdObjectBase`, `MdObjectBaseUtil`, `MdObjectBaseXML`, `PrimaryType`, `Remote`, `Root`

public interface Email extends ContentLocation
An e-mail address.

Attributes of Email are:

- `Address`
- `EmailType`

Associations of Email are:

- `EmailSubscriber`
- `Persons`

## Usage

To create an instance of this Email, use the `factory` create methods.
Example: create a Email with name "Email_Object", in repository "AAAAAAAA".

     // create a store to contain your objects for this change. If you do not have an existing object
     // or store to use.  You may obtain the store from another object by using Object.getObjectStore().
     MdFactory factory; //where "factory" is a valid MdFactory instance
     MdObjectStore objectStore = factory.createObjectStore();
     Email myObject = (Email) factory.createComplexMetadataObject(objectStore, "Email_Object", MetadataObjects.EMAIL, "AAAAAAAA");
     myObject.updateMetadataAll();  // Write object to server
     objectStore.dispose();  // dispose of the object store if it is no longer needed

## Behavior

- Attributes and associations for this object can be retrieved by using the methods in `MdOMIUtil`.
- When changes are made to the object, either by setting an attribute or adding objects to a particular association, they can be persisted to the metadata server with the `updateMetadataAll` method.
- If an object needs to be deleted, the `delete` method can be used. This will flag the object as being deleted on the client, and will require an update call to persist the change to the server.

## Dependencies

This class depends on objects being contained in an MdObjectStore. Object stores should be disposed of when they are no longer needed as this will help clean up memory. Disposing an object store will dispose of all objects contained within that store.

Since:
  9.0

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `ASSOCIATION_EMAILSUBSCRIBER_NAME`
  Constant used for the name of the EmailSubscriber association.
  `static final String`
  `ASSOCIATION_PERSONS_NAME`
  Constant used for the name of the Persons association.
  `static final String`
  `ATTRIBUTE_ADDRESS_NAME`
  Constant used for the name of the Address attribute.
  `static final String`
  `ATTRIBUTE_EMAILTYPE_NAME`
  Constant used for the name of the EmailType attribute.

  ### Fields inherited from interface com.sas.metadata.remote.ContentLocation

  `ASSOCIATION_ASSOCIATEDCONTENTTYPE_NAME, ASSOCIATION_FILEREFS_NAME, ASSOCIATION_REPORTS_NAME, ASSOCIATION_TSASSOCIATEDNAMESPACE_NAME, ASSOCIATION_UNITOFTIMES_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.DeployedDataPackage

  `ASSOCIATION_ALIASES_NAME, ASSOCIATION_ALIASFOR_NAME, ASSOCIATION_DEPLOYEDCOMPONENTS_NAME, ASSOCIATION_TABLECOLLECTIONS_NAME, ASSOCIATION_USEDBYPACKAGES_NAME, ASSOCIATION_USINGPACKAGES_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.MdObjectBase

  `ATTRIBUTE_DESC_NAME, ATTRIBUTE_ID_NAME, ATTRIBUTE_METADATACREATED_NAME, ATTRIBUTE_METADATAUPDATED_NAME, ATTRIBUTE_NAME_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.PrimaryType

  `ASSOCIATION_FAVORITESCONTAINERS_NAME, ATTRIBUTE_ISHIDDEN_NAME, ATTRIBUTE_PUBLICTYPE_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.Root

  `ASSOCIATION_ACCESSCONTROLS_NAME, ASSOCIATION_CHANGES_NAME, ASSOCIATION_CUSTOMASSOCIATIONS_NAME, ASSOCIATION_DOCUMENTS_NAME, ASSOCIATION_EXTENSIONS_NAME, ASSOCIATION_EXTERNALIDENTITIES_NAME, ASSOCIATION_GROUPS_NAME, ASSOCIATION_IMPLEMENTORS_NAME, ASSOCIATION_KEYWORDS_NAME, ASSOCIATION_LOCALIZEDATTRIBUTES_NAME, ASSOCIATION_NOTES_NAME, ASSOCIATION_PRIMARYPROPERTYGROUP_NAME, ASSOCIATION_PROMPTS_NAME, ASSOCIATION_PROPERTIES_NAME, ASSOCIATION_PROPERTYSETS_NAME, ASSOCIATION_REFERENCEDOBJECTS_NAME, ASSOCIATION_RESPONSIBLEPARTIES_NAME, ASSOCIATION_SOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECSOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECTARGETTRANSFORMATIONS_NAME, ASSOCIATION_TARGETTRANSFORMATIONS_NAME, ASSOCIATION_TIMESTAMPS_NAME, ASSOCIATION_TREES_NAME, ASSOCIATION_TSOBJECTNAMESPACE_NAME, ASSOCIATION_USEDBYPROTOTYPES_NAME, ASSOCIATION_USINGPROTOTYPE_NAME, ASSOCIATION_VARIABLES_NAME, ATTRIBUTE_CHANGESTATE_NAME, ATTRIBUTE_LOCKEDBY_NAME, ATTRIBUTE_USAGEVERSION_NAME`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `String`
  `getAddress()`
  Gets the `String` value of `Address`
  `int`
  `getAddressMaxLength()`
  Gets the maximum length of `Address`
  `int`
  `getAddressState()`
  Gets the Metadata State of `Address`
  `AssociationList`
  `getEmailSubscriber()`
  Gets the Association list of `EmailSubscriber`
  `AssociationList`
  `getEmailSubscriber(boolean fGoToServer)`
  Gets the Associationlist of `EmailSubscriber`
  `String`
  `getEmailType()`
  Gets the `String` value of `EmailType`
  `int`
  `getEmailTypeMaxLength()`
  Gets the maximum length of `EmailType`
  `int`
  `getEmailTypeState()`
  Gets the Metadata State of `EmailType`
  `AssociationList`
  `getPersons()`
  Gets the Association list of `Persons`
  `AssociationList`
  `getPersons(boolean fGoToServer)`
  Gets the Associationlist of `Persons`
  `void`
  `initializePredObjects()`
  (S) Adds the Associated objects to the predObjects which are:
  `void`
  `initializeRequiredObjects()`
  (S) This initializes the Required Objects(Roles) which are:
  `void`
  `setAddress(String inAddress)`
  Sets the `Address` value and sets the state to MetadataState.LOCAL.
  `void`
  `setAddress(String inAddress, int state)`
  Sets the `Address` Metadata State.
  `void`
  `setAddressState(int state)`
  Sets the Metadata State of `Address`.
  `void`
  `setEmailSubscriber(AssociationList list)`
  Sets the `EmailSubscriber` list to be `list`.
  `void`
  `setEmailSubscriber(AssociationList inObjects, int state)`
  Sets the entire EmailSubscriber list to match the passed in AssociationList, sets the state of the EmailSubscriber
  `void`
  `setEmailType(String inEmailType)`
  Sets the `EmailType` value and sets the state to MetadataState.LOCAL.
  `void`
  `setEmailType(String inEmailType, int state)`
  Sets the `EmailType` Metadata State.
  `void`
  `setEmailTypeState(int state)`
  Sets the Metadata State of `EmailType`.
  `void`
  `setPersons(AssociationList list)`
  Sets the `Persons` list to be `list`.
  `void`
  `setPersons(AssociationList inObjects, int state)`
  Sets the entire Persons list to match the passed in AssociationList, sets the state of the Persons

  ### Methods inherited from interface com.sas.metadata.remote.ContentLocation

  `getAssociatedContentType, getAssociatedContentTypes, getAssociatedContentTypes, getFileRefs, getFileRefs, getReports, getReports, getTSAssociatedNamespace, getTSAssociatedNamespaces, getTSAssociatedNamespaces, getUnitofTimes, getUnitofTimes, setAssociatedContentType, setAssociatedContentTypes, setAssociatedContentTypes, setFileRefs, setFileRefs, setReports, setReports, setTSAssociatedNamespace, setTSAssociatedNamespaces, setTSAssociatedNamespaces, setUnitofTimes, setUnitofTimes`

  ### Methods inherited from interface com.sas.metadata.remote.DeployedDataPackage

  `getAliases, getAliases, getAliasFor, getAliasFors, getAliasFors, getDeployedComponents, getDeployedComponents, getTableCollections, getTableCollections, getUsedByPackages, getUsedByPackages, getUsingPackages, getUsingPackages, setAliases, setAliases, setAliasFor, setAliasFors, setAliasFors, setDeployedComponents, setDeployedComponents, setTableCollections, setTableCollections, setUsedByPackages, setUsedByPackages, setUsingPackages, setUsingPackages`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBase

  `addElementToChangeList, clearChangeList, getChangeList, getCMetadataType, getDesc, getDescMaxLength, getDescState, getFQID, getId, getIdState, getMetadataCreated, getMetadataCreatedState, getMetadataUpdated, getMetadataUpdatedState, getName, getNameMaxLength, getNameState, getObjectStore, getPredAssociations, getRepositoryID, getRequiredAssociations, getState, isAssociationRequired, isNewObject, isPredAssociation, removeElementFromChangeList, resetObject, resetState, resetStates, setCMetadataType, setDesc, setDesc, setDescState, setFQID, setFQID, setId, setId, setIdState, setMetadataCreated, setMetadataCreated, setMetadataCreatedState, setMetadataUpdated, setMetadataUpdated, setMetadataUpdatedState, setName, setName, setNameState, setObjectStore, setState`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBaseUtil

  `addMdObjectListener, delete, dispose, fireMdObjectModified, getAssociatedObjects, getAssociatedObjects, getAssociatedObjects, getAssociationNames, getAssocs, getAssocsWA, getAttributeNames, getAttrs, getAttrsStates, getAuthorizationUtil, getChangeManagementState, getChgMgtExternalIdentityImportType, getClientSideOnlyObject, getMdObjectAssociation, getPopulatedAssocs, getUpdatedAttrs, getViewList, isCheckedOut, isLocked, objectModified, removeMdObjectListener, setAttrs, setChangeManagementTargetRepository, setChgMgtExternalIdentityImportType, setClientSideOnlyObject, setMdObjectAssociation, touch, updateAssnsIds`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBaseXML

  `closeUpdateMetadataXML, createEmptyXML, createObjectRefreshXML, createObjectXML, createObjectXML, createUpdateAssociationXML, createUpdateAssociationXML, createUpdateSimpleXML, doCreateUpdateXML, getUpdateSimpleSubstring, updateMetadataAll`

  ### Methods inherited from interface com.sas.metadata.remote.PrimaryType

  `getFavoritesContainers, getFavoritesContainers, getIsHidden, getIsHiddenState, getPublicType, getPublicTypeMaxLength, getPublicTypeState, setFavoritesContainers, setFavoritesContainers, setIsHidden, setIsHidden, setIsHidden, setIsHidden, setIsHiddenState, setPublicType, setPublicType, setPublicTypeState`

  ### Methods inherited from interface com.sas.metadata.remote.Root

  `getAccessControls, getAccessControls, getChanges, getChanges, getChangeState, getChangeStateMaxLength, getChangeStateState, getCustomAssociations, getCustomAssociations, getDocuments, getDocuments, getExtensions, getExtensions, getExternalIdentities, getExternalIdentities, getGroups, getGroups, getImplementors, getImplementors, getKeywords, getKeywords, getLocalizedAttributes, getLocalizedAttributes, getLockedBy, getLockedByMaxLength, getLockedByState, getNotes, getNotes, getPrimaryPropertyGroup, getPrimaryPropertyGroups, getPrimaryPropertyGroups, getPrompts, getPrompts, getProperties, getProperties, getPropertySets, getPropertySets, getReferencedObjects, getReferencedObjects, getResponsibleParties, getResponsibleParties, getSourceTransformations, getSourceTransformations, getSpecSourceTransformations, getSpecSourceTransformations, getSpecTargetTransformations, getSpecTargetTransformations, getTargetTransformations, getTargetTransformations, getTimestamps, getTimestamps, getTrees, getTrees, getTSObjectNamespace, getTSObjectNamespaces, getTSObjectNamespaces, getUsageVersion, getUsageVersionState, getUsedByPrototypes, getUsedByPrototypes, getUsingPrototype, getUsingPrototypes, getUsingPrototypes, getVariables, getVariables, setAccessControls, setAccessControls, setChanges, setChanges, setChangeState, setChangeState, setChangeStateState, setCustomAssociations, setCustomAssociations, setDocuments, setDocuments, setExtensions, setExtensions, setExternalIdentities, setExternalIdentities, setGroups, setGroups, setImplementors, setImplementors, setKeywords, setKeywords, setLocalizedAttributes, setLocalizedAttributes, setLockedBy, setLockedBy, setLockedByState, setNotes, setNotes, setPrimaryPropertyGroup, setPrimaryPropertyGroups, setPrimaryPropertyGroups, setPrompts, setPrompts, setProperties, setProperties, setPropertySets, setPropertySets, setReferencedObjects, setReferencedObjects, setResponsibleParties, setResponsibleParties, setSourceTransformations, setSourceTransformations, setSpecSourceTransformations, setSpecSourceTransformations, setSpecTargetTransformations, setSpecTargetTransformations, setTargetTransformations, setTargetTransformations, setTimestamps, setTimestamps, setTrees, setTrees, setTSObjectNamespace, setTSObjectNamespaces, setTSObjectNamespaces, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersionState, setUsedByPrototypes, setUsedByPrototypes, setUsingPrototype, setUsingPrototypes, setUsingPrototypes, setVariables, setVariables`

- ## Field Details

  - ### ATTRIBUTE_ADDRESS_NAME

    static final String ATTRIBUTE_ADDRESS_NAME
    Constant used for the name of the Address attribute.

    Address: The e-mail address

    See Also:
      - Constant Field Values

  - ### ATTRIBUTE_EMAILTYPE_NAME

    static final String ATTRIBUTE_EMAILTYPE_NAME
    Constant used for the name of the EmailType attribute.

    EmailType: The type of e-mail address: such as Home, Work.

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_EMAILSUBSCRIBER_NAME

    static final String ASSOCIATION_EMAILSUBSCRIBER_NAME
    Constant used for the name of the EmailSubscriber association.

    EmailSubscriber: Subscriber profile that uses this email address to deliver content.

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_PERSONS_NAME

    static final String ASSOCIATION_PERSONS_NAME
    Constant used for the name of the Persons association.

    Persons: *Unknown*

    See Also:
      - Constant Field Values

- ## Method Details

  - ### initializeRequiredObjects

    void initializeRequiredObjects() throws RemoteException
    (S) This initializes the Required Objects(Roles) which are:
    Specified by:
      `initializeRequiredObjects` in interface `ContentLocation`
    Specified by:
      `initializeRequiredObjects` in interface `DeployedDataPackage`
    Specified by:
      `initializeRequiredObjects` in interface `MdObjectBaseUtil`
    Specified by:
      `initializeRequiredObjects` in interface `PrimaryType`
    Specified by:
      `initializeRequiredObjects` in interface `Root`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### initializePredObjects

    void initializePredObjects() throws RemoteException
    (S) Adds the Associated objects to the predObjects which are:
    Specified by:
      `initializePredObjects` in interface `ContentLocation`
    Specified by:
      `initializePredObjects` in interface `DeployedDataPackage`
    Specified by:
      `initializePredObjects` in interface `MdObjectBase`
    Specified by:
      `initializePredObjects` in interface `PrimaryType`
    Specified by:
      `initializePredObjects` in interface `Root`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getAddress

    String getAddress() throws RemoteException
    Gets the `String` value of `Address`
    Returns:
      The `Address`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getAddressState

    int getAddressState() throws RemoteException
    Gets the Metadata State of `Address`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getAddressMaxLength

    int getAddressMaxLength() throws RemoteException
    Gets the maximum length of `Address`
    Returns:
      The max size
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getEmailType

    String getEmailType() throws RemoteException
    Gets the `String` value of `EmailType`
    Returns:
      The `EmailType`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getEmailTypeState

    int getEmailTypeState() throws RemoteException
    Gets the Metadata State of `EmailType`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getEmailTypeMaxLength

    int getEmailTypeMaxLength() throws RemoteException
    Gets the maximum length of `EmailType`
    Returns:
      The max size
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getEmailSubscriber

    AssociationList getEmailSubscriber() throws RemoteException, MdException
    Gets the Association list of `EmailSubscriber`
    Returns:
      The AssociationList of `EmailSubscriber` which can be of type:
      ITSubscriber
      ITContentSubscriber
      ITEventSubscriber
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getPersons

    AssociationList getPersons() throws RemoteException, MdException
    Gets the Association list of `Persons`
    Returns:
      The AssociationList of `Persons` which can be of type:
      Person
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getEmailSubscriber

    AssociationList getEmailSubscriber(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `EmailSubscriber`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the `EmailSubscriber` which can be of type:
      ITSubscriber
      ITContentSubscriber
      ITEventSubscriber
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getPersons

    AssociationList getPersons(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `Persons`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the `Persons` which can be of type:
      Person
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### setAddress

    void setAddress(String inAddress) throws RemoteException
    Sets the `Address` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inAddress` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setAddress

    void setAddress(String inAddress, int state) throws RemoteException
    Sets the `Address` Metadata State.
    Parameters:
      `inAddress` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setAddressState

    void setAddressState(int state) throws RemoteException
    Sets the Metadata State of `Address`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setEmailType

    void setEmailType(String inEmailType) throws RemoteException
    Sets the `EmailType` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inEmailType` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setEmailType

    void setEmailType(String inEmailType, int state) throws RemoteException
    Sets the `EmailType` Metadata State.
    Parameters:
      `inEmailType` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setEmailTypeState

    void setEmailTypeState(int state) throws RemoteException
    Sets the Metadata State of `EmailType`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setEmailSubscriber

    void setEmailSubscriber(AssociationList list) throws RemoteException
    Sets the `EmailSubscriber` list to be `list`. Objects of which can be of type:
    ITSubscriber
    ITContentSubscriber
    ITEventSubscriber
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setEmailSubscriber

    void setEmailSubscriber(AssociationList inObjects, int state) throws RemoteException
    Sets the entire EmailSubscriber list to match the passed in AssociationList, sets the state of the EmailSubscriber
    Parameters:
      `inObjects` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setPersons

    void setPersons(AssociationList list) throws RemoteException
    Sets the `Persons` list to be `list`. Objects of which can be of type:
    Person
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setPersons

    void setPersons(AssociationList inObjects, int state) throws RemoteException
    Sets the entire Persons list to match the passed in AssociationList, sets the state of the Persons
    Parameters:
      `inObjects` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.